#!/usr/bin/env python
# -*- coding: utf-8
import Ice, sys


Ice.loadSlice('/usr/share/slice/Murmur.ice')
import Murmur

class MetaCallbackI(Murmur.MetaCallback):
    def started(self, s, current=None):
        serverR=Murmur.ServerCallbackPrx.uncheckedCast(adapter.addWithUUID(ServerCallbackI(server, current.adapter)))
        s.addCallback(serverR)
        
    def stopped(self, s, current=None):
        pass

class ServerCallbackI(Murmur.ServerCallback):
    def __init__(self, server, adapter):
        self.server = server
        self.servername = server.getConf("registername")
        self.contextR=Murmur.ServerContextCallbackPrx.uncheckedCast(adapter.addWithUUID(ServerContextCallbackI(server)))
	def dispose(self, current=None):
		self.server.removeContextCallback(self.contextR)

    def channelCreated(self, c, current=None):
        pass
    
    def channelRemoved(self, c, current=None):
        pass

    def channelStateChanged(self, c, current=None):
        pass

    def userStateChanged(self, c, current=None):
        pass

    def userConnected(self, c, current=None):
		self.server.addContextCallback(c.session, "unregist", "ユーザ登録を解除", self.contextR, Murmur.ContextUser)
		self.server.addContextCallback(c.session, "serverinfo", "サーバの詳細情報を表示", self.contextR, Murmur.ContextServer |  Murmur.ContextUser | Murmur.ContextChannel)

    def userDisconnected(self, c, current=None):
        pass

class ServerContextCallbackI(Murmur.ServerContextCallback):
    def __init__(self, server):
        self.server = server

    def contextAction(self, action, usr, session, chanid, current=None):
    	if action == "unregist":
			if session == usr.session :
				if self.server.getRegisteredUsers(usr.name) <> {}:
					self.server.unregisterUser(usr.userid) 
				else:
					self.server.sendMessage(usr.session, "あなたはユーザ登録されていません。")
			elif self.server.hasPermission(usr.session, 0, Murmur.PermissionRegister):
				tmp = self.server.getState(session)
				if tmp.userid <> -1:
					self.server.unregisterUser(tmp.userid) 
			else:
				self.server.sendMessage(usr.session, "他人の登録は解除できません。")
    	elif action == "serverinfo" :
    		self.server.sendMessage(usr.session, open('messege.html').read())

if __name__ == "__main__":
    global contextR

    print "Creating callbacks...",
    ice = Ice.initialize(sys.argv)

    meta = Murmur.MetaPrx.checkedCast(ice.stringToProxy('Meta:tcp -h 127.0.0.1 -p 6502'))

    adapter = ice.createObjectAdapterWithEndpoints("Callback.Client", "tcp -h 127.0.0.1")

    for server in meta.getBootedServers():
        serverR=Murmur.ServerCallbackPrx.uncheckedCast(adapter.addWithUUID(ServerCallbackI(server, adapter)))
        server.addCallback(serverR)

    metaR=Murmur.MetaCallbackPrx.uncheckedCast(adapter.addWithUUID(MetaCallbackI()))
    adapter.activate()

    meta.addCallback(metaR)
    
    print "Done"
    print 'Script running (press CTRL-C to abort)';
    try:
        ice.waitForShutdown()
    except KeyboardInterrupt:
        print 'CTRL-C caught, aborting'

    meta.removeCallback(metaR)
    ice.shutdown()
    print "Goodbye"
